#include "prescan.h"

void output(struct host *);

void output(struct host *victim)
{
  char *file_name;
  FILE *output_f;
  time_t timestamp;

  print_it:
  if(config.stdout_o && output_f != stdout)
    output_f = stdout;

  else if(config.savescan)
  {
    file_name = (char*) Malloc(16 + strlen(EXT));
    sprintf(file_name,EXT,Inet_ntoa(victim->ip));

    output_f = fopen(file_name,"a");
    if(output_f == NULL)
    {
      perror("error opening output file");
      exit(-1);
    }
  }

  timestamp = time(NULL);

  if(config.stealth)
    fprintf(output_f,"[----> STEALTH SCAN ON [%s] COMPLETED IN %d SECONDS\n",victim->host,(timestamp-victim->scan_time));
  else
    fprintf(output_f,"[----> SCAN ON [%s] COMPLETED IN %d SECONDS\n",victim->host,(timestamp-victim->scan_time));

  fprintf(output_f,"[> HOST:\t%s (%s)\n",Inet_ntoa(victim->ip),(victim->name ? victim->name : "DNS NAME UNKNOWN"));
  fprintf(output_f,"[> SCAN TIME:\t%s",ctime(&timestamp));
  fprintf(output_f,"[> OS TYPE:\t%s\n",(victim->os ? victim->os : "UNKNOWN"));

  if(config.stealth)
    fprintf(output_f,"[> PING REPLY:\tN/A  (STEALTH MODE)\n");
  else
    fprintf(output_f,"[> PING REPLY:\t%s\n",(victim->ping_reply ? "YES" : "NO"));

  victim->tcp_current=victim->tcp_first;

  fprintf(output_f,"[----> TCP PORTS\n");

  fprintf(output_f,"[> OPEN:\t");
  for(victim->tcp_current=victim->tcp_first; victim->tcp_current; victim->tcp_current = victim->tcp_current->next)
  {
    if(victim->tcp_current->open)
      fprintf(output_f,"[%d] ",victim->tcp_current->port);
  }
  fprintf(output_f,"\n");

  fprintf(output_f,"[> REJECTED:\t");
  for(victim->tcp_current=victim->tcp_first; victim->tcp_current; victim->tcp_current = victim->tcp_current->next)
    if(victim->tcp_current->state == REJECTED)
      fprintf(output_f,"[%d] ",victim->tcp_current->port);
  fprintf(output_f,"\n");
  fprintf(output_f,"[> NO ROUTE:\t");
  for(victim->tcp_current=victim->tcp_first; victim->tcp_current; victim->tcp_current = victim->tcp_current->next)
    if(victim->tcp_current->state == NOROUTE)
      fprintf(output_f,"[%d] ",victim->tcp_current->port);
  fprintf(output_f,"\n");

  fprintf(output_f,"[> UNREACHABLE:\t");
  for(victim->tcp_current=victim->tcp_first; victim->tcp_current; victim->tcp_current = victim->tcp_current->next)
    if(victim->tcp_current->state == N_UNREACH)
      fprintf(output_f,"[%d] ",victim->tcp_current->port);
  fprintf(output_f,"\n");

  if(config.stealth) 
    fprintf(output_f,"[----> BANNERS (N/A, STEALTH MODE)\n");
  else
    fprintf(output_f,"[----> BANNERS\n");

  if(victim->pop3_banner)
    fprintf(output_f,"[> POP3: %s\n",victim->pop3_banner);
  if(victim->imap_banner)
    fprintf(output_f,"[> IMAP: %s\n",victim->imap_banner);
  if(victim->smtp_banner)
    fprintf(output_f,"[> SMTP: %s\n",victim->smtp_banner);
  if(victim->http_server)
    fprintf(output_f,"[> HTTP: %s\n",victim->http_server);
  if(victim->bind_version)
    fprintf(output_f,"[> DNS: %s\n",victim->bind_version);
  if(victim->ftp_banner)
  {
    fprintf(output_f,"[> FTP : %s\n",victim->ftp_banner);
    if(victim->ftp_syst)
      fprintf(output_f,"[> FTP SYST: %s\n",victim->ftp_syst);
    if(victim->anonymous_ftp)
      fprintf(output_f,"[> FTP supports anonymous logins.\n");
    else
      fprintf(output_f,"[> FTP does NOT support anonymous logins.\n");
  }
  if(victim->telnet_banner)
    fprintf(output_f,"[> TELNET: %s\n",victim->telnet_banner);
  if(config.savescan && output_f == stdout) goto print_it; /* goto rulez, motherfucker. */

  if(config.savescan)
  {
    fclose(output_f);
    printf("[----> SCAN SAVED: %s\n\n",file_name);
  }
  free(file_name);
}
